
#ifndef _GWIRELESS_CALLS_H_
#define _GWIRELESS_CALLS_H_


#include <sys/types.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <math.h>
#include <errno.h>
#include <fcntl.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netdb.h>      /* gethostbyname, getnetbyname */
#include <linux/if_arp.h>   /* For ARPHRD_ETHER */
#include <linux/socket.h>   /* For AF_INET & struct sockaddr */
#include <sys/socket.h>       /* For struct sockaddr_in */
#include <linux/wireless.h>




typedef struct iw_statistics    iwstats;
typedef struct iw_range     iwrange;
typedef struct iw_param     iwparam;
typedef struct iw_freq      iwfreq;
typedef struct iw_priv_args iwprivargs;
typedef struct sockaddr     sockaddr;


typedef struct iw_info
{

  	char      name[IFNAMSIZ];     /* Wireless/protocol name */
  	int       has_nwid;
  	iwparam   nwid;           /* Network ID */
  	int       has_freq;
  	float     freq;           /* Frequency/channel */
  	int       has_sens;
  	iwparam   sens;           /* sensitivity */
  	int       has_key;
  	unsigned char key[IW_ENCODING_TOKEN_MAX]; /* Encoding key used */
  	int       key_size;       /* Number of bytes */
  	int       key_flags;      /* Various flags */
  	int       has_essid;
  	int       essid_on;
  	char      essid[IW_ESSID_MAX_SIZE + 1];   /* ESSID (extended network) */
  	int       has_nickname;
  	char      nickname[IW_ESSID_MAX_SIZE + 1]; /* NickName */
  	int       has_ap_addr;
  	sockaddr  ap_addr;        /* Access point address */
  	int       has_bitrate;
  	iwparam   bitrate;        /* Bit rate in bps */
  	int       has_rts;
  	iwparam   rts;            /* RTS threshold in bytes */
  	int       has_frag;
  	iwparam   frag;           /* Fragmentation threshold in bytes */
  	int       has_mode;
  	int       mode;           /* Operation mode */
  	int       has_power;
  	iwparam   power;          /* Power management parameters */
	
  	/* Stats */
  	iwstats   stats;
  	int       has_stats;
  	iwrange   range;
  	int       has_range;
} InterfaceInfo;

int parse_procwireless(InterfaceInfo *);
int grab_iw_info(InterfaceInfo *);
int determine_max_values(InterfaceInfo*);
void initialize_iwinfo(InterfaceInfo *);

int set_iw_info(InterfaceInfo * old_info);

#endif
