#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#define DEBUG 1
/*#include "interface.h"
#include "support.h"
#include "gwireless_applet.h"
*/


void
on_DetailSetDialog_apply               (GnomePropertyBox *gnomepropertybox,
                                        gint             arg1,
                                        gpointer         user_data)
{
		WirelessManager *wdata = user_data;
		gchar * new_essid;
		gchar * new_nick;
		InterfaceInfo iw_info;
		int changed;
		int size;
		gchar * new_key;

		gboolean managed;

		gboolean power_on;
		gboolean enc_on;

#ifdef DEBUG
		g_print ( "got page # %d\n", arg1 );
#endif

		initialize_iwinfo(&iw_info);

		strcpy (iw_info.name, wdata->iw_info.name);

		switch (arg1)
		{

			case 0:

					new_essid = gtk_editable_get_chars((GtkEditable*) wdata->netname_fld,
										0, -1);
					new_nick = gtk_editable_get_chars((GtkEditable*) wdata->nickname_fld,
										0, -1);

					managed = gtk_toggle_button_get_active((GtkToggleButton*)wdata->managed_rb);

					if ((size = strlen(new_essid)) > 0)
					{
						if (size <= IW_ESSID_MAX_SIZE)
						{

							strncpy(iw_info.essid, new_essid, IW_ESSID_MAX_SIZE);
							iw_info.essid[IW_ESSID_MAX_SIZE] = '\0';
							iw_info.has_essid = 1;
						}
					}

					if (( size = strlen(new_nick)) > 0)
					{
						if (size <= IW_ESSID_MAX_SIZE)
						{
							strncpy(iw_info.nickname, new_nick, IW_ESSID_MAX_SIZE);
							iw_info.nickname[IW_ESSID_MAX_SIZE] = '\0';
							iw_info.has_nickname = 1;
						}
					}

					if (managed)
					{
						iw_info.mode = MANAGED;
					} else {
						iw_info.mode = ADHOC;
					}

					iw_info.has_mode = 1;
#ifdef DEBUG
					g_print(new_essid);
					g_print("\n");
					g_print(new_nick);
					g_print("\n");
					g_print("%d", iw_info.mode);
					g_print("\n");
#endif
					set_iw_info(&iw_info);

					g_free(new_essid);
					g_free(new_nick);

					break;

			case 1:
					enc_on = gtk_toggle_button_get_active((GtkToggleButton*)wdata->encswitch);
					new_key = gtk_editable_get_chars((GtkEditable*) wdata->key_fld,
														0, -1);

					iw_info.has_key = 1;

					iw_info.key_flags = wdata->iw_info.key_flags;

					if (enc_on)
					{

							if ((wdata->iw_info.key_flags & IW_ENCODE_DISABLED))
							{
									iw_info.key_flags &= ~IW_ENCODE_DISABLED;

									strncpy(iw_info.key, wdata->iw_info.key, IW_ENCODING_TOKEN_MAX);
									iw_info.key[IW_ENCODING_TOKEN_MAX-1] = '\0';
	
									iw_info.key_size = wdata->iw_info.key_size;
							
							} else {

								if (strlen(new_key) <= 0 )
								{
									iw_info.key_flags |= IW_ENCODE_DISABLED;
	
									strncpy(iw_info.key, wdata->iw_info.key, IW_ENCODING_TOKEN_MAX);
									iw_info.key[IW_ENCODING_TOKEN_MAX-1] = '\0';
	
									iw_info.key_size = wdata->iw_info.key_size;
	
								} else {
									iw_info.key_flags &= ~IW_ENCODE_DISABLED;
	
									strncpy(iw_info.key, new_key, IW_ENCODING_TOKEN_MAX);
									iw_info.key[IW_ENCODING_TOKEN_MAX-1] = '\0';
	
									iw_info.key_size = strlen(new_key);
	
								}
							} 

					} else {
							iw_info.key_flags |= IW_ENCODE_DISABLED;

							strncpy(iw_info.key, wdata->iw_info.key, IW_ENCODING_TOKEN_MAX);
							iw_info.key[IW_ENCODING_TOKEN_MAX-1] = '\0';

							iw_info.key_size = wdata->iw_info.key_size;
					}

#ifdef DEBUG
					g_print("%x %d %d\n", iw_info.key_flags, enc_on, wdata->iw_info.key_flags & IW_ENCODE_DISABLED);
#endif
					set_iw_info(&iw_info);

					g_free(new_key);

					break;

			case 2:
					power_on = gtk_toggle_button_get_active((GtkToggleButton*)wdata->power_toggle);

					if (power_on)
							iw_info.power.disabled = 0;
					else
							iw_info.power.disabled = 1;

					iw_info.has_power = 1;
#ifdef DEBUG
					g_print("%d", power_on);
					g_print("\n");
#endif
					set_iw_info(&iw_info);

					break;

			default:
					refresh_values(wdata);


	}




}


void
on_DetailSetDialog_help                (GnomePropertyBox *gnomepropertybox,
                                        gint             arg1,
                                        gpointer         user_data)
{

}


gint
on_DetailSetDialog_close               (GnomeDialog     *gnomedialog,
                                        gpointer         user_data)
{

	WirelessManager * wdata = user_data;

	wdata->DetailSetDialog = NULL;

	return FALSE;
	

}

gint
on_DetailSetDialog_destroy              (GnomeDialog     *gnomedialog,
                                        gpointer         user_data)
{
	WirelessManager * wdata = user_data;

	wdata->DetailSetDialog = NULL;

#ifdef DEBUG
	g_print("got destroy event\n");
#endif

	gtk_exit(0);

	return FALSE;
}

void
on_entry_changed                       (GtkEditable     *editable,
                                        gpointer         user_data)
{
	gnome_property_box_changed((GnomePropertyBox *)user_data);
}


void
on_toggle_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
    gnome_property_box_changed((GnomePropertyBox *)user_data);
}



