/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include "gwireless.h"


int
main (int argc, char *argv[])
{
  GtkWidget *DetailSetDialog;
	WirelessManager * wdata;

	wdata = g_new(WirelessManager, 1);


#ifdef ENABLE_NLS
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
#endif

  gnome_init ("gwireless", VERSION, argc, argv);
  gnome_window_icon_set_default_from_file (GNOME_ICONDIR"/gwireless.png");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  DetailSetDialog = create_DetailSetDialog (wdata);

/*g_print("Hello There!");*/
	gtk_window_set_modal(GTK_WINDOW(DetailSetDialog),TRUE);

	refresh_values(wdata);

  gtk_widget_show (DetailSetDialog);

  gtk_main ();
  return 0;
}

void refresh_values(gpointer indata)
{
	int status = 1;
	WirelessManager * wdata = indata;

	status = parse_procwireless(&wdata->iw_info);

	if (status)
			g_error(_("wireless extensions problem"));
	grab_iw_info(&wdata->iw_info);

	gtk_entry_set_text((GtkEntry*)wdata->netname_fld, wdata->iw_info.essid);
	gtk_entry_set_text((GtkEntry*)wdata->nickname_fld, wdata->iw_info.nickname);

	if (wdata->mode == 1)
	{
        	gtk_toggle_button_set_active ( (GtkToggleButton *) wdata->adhoc_rb, TRUE);
        	gtk_toggle_button_set_active ( (GtkToggleButton *) wdata->managed_rb, FALSE);
	} else if (wdata->mode == 2)
	{
        	gtk_toggle_button_set_active ( (GtkToggleButton *) wdata->adhoc_rb, FALSE);
        	gtk_toggle_button_set_active ( (GtkToggleButton *) wdata->managed_rb, TRUE);
	} else {
        	gtk_toggle_button_set_active ( (GtkToggleButton *) wdata->adhoc_rb, FALSE);
        	gtk_toggle_button_set_active ( (GtkToggleButton *) wdata->managed_rb, FALSE);
	}

	
	if (wdata->iw_info.has_key == 1)
	{
		if ((wdata->iw_info.key_flags & IW_ENCODE_DISABLED) || (wdata->iw_info.key_size==0))
		{
        	g_print("encryption off: %d\n", wdata->has_key);
        	gtk_toggle_button_set_active ((GtkToggleButton *) wdata->encswitch, FALSE);
        	gtk_entry_set_text((GtkEntry*)wdata->key_fld, "");
			gtk_widget_set_sensitive ((GtkWidget *)wdata->key_fld, FALSE);
		} else {
        	g_print("encryption on\n");
        	gtk_toggle_button_set_active ((GtkToggleButton *) wdata->encswitch, TRUE);
        	gtk_entry_set_text((GtkEntry*)wdata->key_fld, wdata->iw_info.key);
			gtk_widget_set_sensitive ((GtkWidget *)wdata->key_fld, TRUE);
		}

	}else{
        	gtk_toggle_button_set_active ((GtkToggleButton *) wdata->encswitch, FALSE);
        	gtk_entry_set_text((GtkEntry*)wdata->key_fld, "");
			gtk_widget_set_sensitive ((GtkWidget *)wdata->key_fld, FALSE);
	}

	if (wdata->iw_info.has_power == 1)
	{

		if (wdata->iw_info.power.disabled)
		{
			gtk_toggle_button_set_active ( (GtkToggleButton *) wdata->power_toggle, FALSE);
		} else {
			gtk_toggle_button_set_active ( (GtkToggleButton *) wdata->power_toggle, TRUE);
		}
	} 

	gnome_property_box_set_state((GnomePropertyBox*) wdata->DetailSetDialog, FALSE);

}
