/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "gwireless_applet.h"

void showDetails(AppletWidget *applet, gpointer data)
{

		WirelessApplet * wdata = data;
		gint cpid;
		gchar ** targv;

		targv = g_strsplit("gwireless",
							" ", 0);

		cpid = gnome_execute_async(NULL, 1, targv );
		
		if (cpid == -1)
				g_message(_("failed to execute gwireless!"));

}


int
main (int argc, char *argv[])
{
  GtkWidget *applet;


#ifdef ENABLE_NLS
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
#endif

  /*gnome_init ("gwireless_applet", VERSION, argc, argv);*/
  applet_widget_init("gwireless_applet", VERSION, argc, argv, NULL,0,NULL);

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  /* DetailSetDialog = create_DetailSetDialog ();*/
  /* create a new applet_widget */
	applet = applet_widget_new("gwireless_applet");
        /* in the rare case that the communication with the panel
         *            failed, error out */
        if (!applet)
                g_error("Can't create applet!\n");

        /* create the widget we are going to put on the applet */

		if (!initialize_display((AppletWidget *)applet))
		{
				g_error("Initialization Failed");
		}

        /* special corba main loop */
        applet_widget_gtk_main ();
  return 0;
}

gint initialize_display(AppletWidget *applet)
{

  		WirelessApplet * wdata; 

		wdata = g_new(WirelessApplet, 1);
		wdata->ifname = NULL;
		wdata->DetailSetDialog=NULL;

		wdata->block_color.red = 0;
		wdata->block_color.green = 0;
		wdata->block_color.blue = 0;

		wdata->applet = (GtkWidget *)applet;
		wdata->main_box = gtk_hbox_new(TRUE, 2);

		wdata->signalwidget = gtk_drawing_area_new();
		gtk_container_add(GTK_CONTAINER(wdata->main_box), wdata->signalwidget);

		wdata->update_to_id = gtk_timeout_add(2000, 
									(GtkFunction) signal_update,
									wdata);
		gtk_widget_show(wdata->main_box);
		gtk_widget_show(wdata->signalwidget);


		applet_widget_register_stock_callback(APPLET_WIDGET(applet),
						"settings",
						GNOME_STOCK_MENU_PROP,
						_("Detailed Settings"),
						showDetails,
						wdata);

		gtk_signal_connect(GTK_OBJECT(applet), "change_orient",
							GTK_SIGNAL_FUNC(on_applet_change_orient),
							wdata);

#ifdef HAVE_PANEL_PIXEL_SIZE
		gtk_signal_connect(GTK_OBJECT(applet), "change_pixel_size",
							GTK_SIGNAL_FUNC(on_applet_change_pixel_size),
							wdata);
#endif

		gtk_signal_connect(GTK_OBJECT(wdata->signalwidget), "expose_event",
							GTK_SIGNAL_FUNC(on_signalwidget_expose_event),
							wdata);

        /* add the widget to the applet-widget, and thereby actually
         *            putting it "onto" the panel */
        applet_widget_add (APPLET_WIDGET (applet), wdata->main_box);

        gtk_widget_show ((GtkWidget*)applet);

		wdata->myGC = gdk_gc_new (wdata->signalwidget->window);

	signal_update(wdata);

}

gint signal_update(gpointer indata)
{
		static int initialized = 0;

		GdkColormap *mymap;
		GdkColor myColor;
		GdkColor black_color;
		GdkGC * myGC;
		GdkDrawable * myDrawable;
		gboolean force = FALSE;

/*		gint max = MAX_LINK_QUALITY;*/

		gint temp;
		gint temp2;
		gint reading_l, reading_n;
		gint ceiling_l = MAX_LINK_QUALITY;
		gint floor_n = MAX_NOISE;
		/*gint update = 0;*/
		gint left=0;
		gint top=0;
		gint diameter=0;

		gint status=0;

		WirelessApplet * wdata = indata;

		force = wdata->force;

		status = parse_procwireless(&wdata->iw_info);

		if (!status)
		{
				wdata->link_quality = wdata->iw_info.stats.qual.qual;
				if (!initialized)
				{
					determine_max_values(&wdata->iw_info);
					initialized = 1;
				}

			temp = ceiling_l - wdata->link_quality;
			if (temp < 0)
			{
				reading_l = ceiling_l;
			} else 
					reading_l = wdata->link_quality;
	
			/* iwconfig decides to use dbm display by the following
		 	* logic.  I'm not sure if this works, but for now
		 	* iwconfig will be considered cannon.
		 	*/
			if (wdata->noise > wdata->iw_info.range.max_qual.noise)
			{
	
				/*g_print("bob %d\n", temp);*/
		
				temp2 = wdata->noise - (256 - floor_n);
				if (temp2 < 0)
						reading_n = 0;
				else 
						reading_n = temp2;
		
			
			} else {

				/* this is if the level values are in a ratio vs. in 
			 	* raw dbms.
			 	*/
			}
	
			myColor.green = (gushort) ((reading_l * 65535)/ceiling_l);
			myColor.red = (gushort) 65535 - myColor.green; /*((temp2 * 65535)/MAX_NOISE);*/
			myColor.blue = 0;
		} else {

				myColor.red = (gushort) 0;
				myColor.green = (gushort) 0;
				myColor.blue = (gushort) 65535;

		}

			
		if (myColor.green != wdata->block_color.green ||
						myColor.red != wdata->block_color.red || force == TRUE)
		{

			wdata->block_color.green = myColor.green;
			wdata->block_color.red = myColor.red;

#ifdef DEBUG
			g_print("%d, %d, %d\n", myColor.red, myColor.green, myColor.blue);
#endif

			myDrawable = wdata->signalwidget->window;

			mymap = gtk_widget_get_colormap (wdata->signalwidget);

			gdk_color_alloc (mymap, &(myColor));
			gdk_color_black (mymap, &(black_color));

			myGC = wdata->myGC;

			gdk_window_clear(wdata->signalwidget->window);

			/* draw the picture.  Used to be a basic rectangle.  Let's 
			 * get a little more "exotic" with a circle. ;-)
			 */

			/* gdk_draw_rectangle(myDrawable, myGC, TRUE,
			 *		0,0,48,48);
			 */
			left = (wdata->size - (PIXEL_SIZE_TINY/2))/2;
			top = (wdata->size - (PIXEL_SIZE_TINY/2))/2;

			if ( left < 0 )
					left = 0;

			if (wdata->size < PIXEL_SIZE_TINY)
			{
				diameter = wdata->size;
			} else {
				diameter = PIXEL_SIZE_TINY;
			}

			gdk_gc_set_foreground(myGC, &myColor);
			/*gdk_gc_set_line_attributes(myGC,0,GDK_LINE_SOLID,
							GDK_CAP_BUTT,GDK_JOIN_MITER);*/
			gdk_draw_arc (myDrawable, 
							myGC, 
							TRUE, 
							left, 
							top, 
							diameter/2,
							diameter/2,
							0,
							360*64);

			gdk_gc_set_foreground(myGC, &black_color);
			/*gdk_gc_set_line_attributes(myGC,2,GDK_LINE_SOLID,
							GDK_CAP_BUTT,GDK_JOIN_MITER);*/

			gdk_draw_arc (myDrawable, 
							myGC, 
							FALSE, 
							left, 
							top, 
							diameter/2,
							diameter/2,
							0,
							360*64);
		}

		return TRUE;

}

